Unit Batch_Macro32;

Interface

Uses

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

Type

  TfrmBatch_Macro = Class(TForm)
    Label1            : TLabel;
    Label2            : TLabel;
    Label3            : TLabel;
    BtnOK             : TButton;
    BtnCancel         : TButton;
    MacroName         : TEdit;
    OutputPrefix      : TEdit;
    Label4            : TLabel;
    Label5            : TLabel;
    Mask              : TEdit;
    ComboBox1         : TComboBox;
    DirectoryListBox1 : TDirectoryListBox;
    DriveComboBox1    : TDriveComboBox;
    procedure BtnOKClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Var

  frmBatch_Macro        : TfrmBatch_Macro;

Implementation

Uses Idrisi32_TLB;                            {This is the reference to the IDRISI32 API Type Library}

{$R *.DFM}

Var

  OutPrefix, OutputIML  : String;
  FolderName            : String;
  Idrisi32              : IIdrisiAPIServer;   {type declared in the IDRISI32 API Type Library}

Function Create_File_List(MaskString : String; FList : TStringList) : Boolean;

Var

 SearchRec              : TSearchRec;
 ffResult               : Integer;

Begin

   Result:=True; {initialize result as successful}
   try
     FList.Sorted:=True; {set up as a sorted list}
     ffResult := FindFirst(FolderName + MaskString, faAnyFile, SearchRec);
     if ffResult = 0 then {search was successful}
        begin
           if (SearchRec.Name <> '.') and (SearchRec.Name <> '...') then
             FList.Add(Lowercase(SearchRec.Name));
           while (FindNext(SearchRec) = 0) do
            if (SearchRec.Attr and faDirectory) <= 0 then
              begin
                 if (SearchRec.Name <> '.') and (SearchRec.Name <> '...') then
                   FList.Add(Lowercase(SearchRec.Name));
              end;
        end;
     FindClose(SearchRec);
   except
     Result:=False; {unsuccessful}
   end;

End;

Function ExtractFileNameNoExt(FileName : String) : String;

Var

   TmpStr1, TmpStr2 : String;

Begin

   TmpStr1:=ExtractFileExt(FileName);
   TmpStr2:=Copy(FileName,1,(Length(FileName)-Length(TmpStr1)));
   Result :=TmpStr2;

End;

Function Create_OutputIML(InputIML : String; FileList : TStringList): Boolean;

Var Counter        : Integer;
    InIML, OutIML  : TextFile;
    FullName       : String;
    ShortName      : String;
    OutFileName    : String;
    TmpStr,TmpStr2 : String;
    Posn,Posn2     : Integer;

Begin

  Result:=True;
  try
      AssignFile(InIML,InputIML);
      AssignFile(OutIML,OutputIML);
      ReWrite(OutIML);

      FileMode:=0;
      for Counter:=0 to (FileList.Count-1) do
        begin
          Reset(InIML);  {start at top of macro file - for each filename in the list}
          FullName := FolderName + FileList.Strings[Counter];
          ShortName:= ExtractFileNameNoExt(FileList.Strings[Counter]);
          OutFileName:=FolderName+OutPrefix+FileList.Strings[Counter];

          while not Eof(InIML) do
            begin
               Readln(InIML,TmpStr);
               TmpStr:=UpperCase(TmpStr);

               {insert input name into macro line}
               Posn:=Pos('%1',TmpStr);
               while Posn>0 do
                 begin
                   TmpStr:=Copy(TmpStr,1,Posn-1) + FullName + Copy(TmpStr,Posn+2,Length(TmpStr)-(Posn+1));
                   Posn:=Pos('%1',TmpStr);
                 end;

               {insert output name into macro line}
               Posn:=Pos('%2',TmpStr);
               while Posn>0 do
                 begin
                    if Length(TmpStr) >= Posn+4 then TmpStr2:=Copy(TmpStr,Posn+2,4)
                        else if Length(TmpStr) >= Posn + 3 then TmpStr2:=Copy(TmpStr,Posn+2,3)
                         else if Length(TmpStr) >= Posn + 2 then TmpStr2:=Copy(TmpStr,Posn+2,2)
                          else if Length(TmpStr) >= Posn + 1 then TmpStr2:=Copy(TmpStr,Posn+2,1)
                           else TmpStr2:=' ';

                       Posn2:=Pos('*',TmpStr2);
                       if Posn2 > 0 then
                         begin
                          TmpStr:=Copy(TmpStr,1,Posn-1) +
                                FolderName +
                                 OutPrefix +
                                  Copy(TmpStr,Posn+2,Posn2-1) +   {number of outfile}
                                   FileList.Strings[Counter] +     {filename}
                                    Copy(TmpStr,Posn+2+(Posn2-1),(Length(TmpStr)-(Posn+2)-(Posn2-1))+1 ); {after outfile until end}
                         end
                       else {nothing comes after the filename in the command line}
                         begin
                          if TmpStr2=' ' then Posn2:=2
                          else if Length(TmpStr2)=1 then Posn2:=3
                            else if Length(TmpStr2)=2 then Posn2:=4
                             else if Length(TmpStr2)=3 then Posn2:=5;
                          TmpStr:=Copy(TmpStr,1,Posn-1) +
                                FolderName +
                                 OutPrefix +
                                  Copy(TmpStr,Posn+2,Posn2-1) +   {number of outfile}
                                   FileList.Strings[Counter];       {filename}
                         end;

                   Posn:=Pos('%2',TmpStr);
                 end;

               writeln(OutIML,TmpStr);
            end;  {while not Eof(inIML)}
        end;
        FileMode:=2;
        CloseFile(OutIML);
        CloseFile(InIML);
  except
     Result:=False;
  end;

End;

Procedure TfrmBatch_Macro.BtnOKClick(Sender: TObject);

Var

  FileList         : TStringlist;
  Success,Success2 : Boolean;
  MaskStr          : String;
  InputIML         : String;
  ProcID           : Integer;
  Kounter,Lines    : Integer;
  Posn             : Integer;
  IML              : TextFile;
  MacroText        : String;
  Modname,Cmdln    : String;

Begin

    {register the module as a process to be monitored by IDRISI}

    ProcID:=Idrisi32.AllocateProcess;
    Idrisi32.Set_Process_ModuleName(ProcID,'Batch_Macro');

    {determine the input and output file names}

    FolderName:=Trim(DirectoryListBox1.Directory);
    if FolderName[Length(FolderName)]<> '\' then FolderName:=FolderName + '\';
    MaskStr:=Trim(Mask.Text);
    OutPrefix:=Trim(OutputPrefix.Text);
    OutputIML:=FolderName + 'idrtmp.IML';
    InputIML:=Trim(MacroName.Text);


    {create a list of files in the directory -- call it FileList.}

    FileList:=TStringList.Create;
    Success:=Create_File_List(MaskStr, FileList);

    if Success then
       begin
          Success2:=Create_OutputIML(InputIML, FileList);
          if Success2 then
            begin

              {first, read the file to see how many macro lines it contains}
              Lines:=0;
              AssignFile(IML,OutputIML);
              Reset(IML);
              repeat
                 {read the macro line}
                 Readln(IML,MacroText);
                 MacroText:=LowerCase(MacroText);
                 {skip the line if it is a remark}
                 Posn:=0;
                 if LowerCase(Copy(MacroText,1,4))<>'rem ' then Posn:=Pos(' x ',MacroText);
                 {if a valid macro line has been found, increment the number of lines}
                 if Posn>0 then Lines:=Lines+1;
              until Eof(IML);
              CloseFile(IML);

              {now read and process the file}
              AssignFile(IML,OutputIML);
              Reset(IML);
              Kounter:=0;
              repeat
                 {read the macro line}
                 Readln(IML,MacroText);
                 MacroText:=lowercase(MacroText);
                 {skip the line if it is a remark}
                 Posn:=0;
                 if LowerCase(Copy(MacroText,1,4))<>'rem ' then Posn:=Pos(' x ',MacroText);
                 if Posn>0 then
                   begin
                     {a valid macro line has been found}
                     Kounter:=Kounter+1;
                     {extract the module name}
                     ModName:=Copy(MacroText,1,Posn-1);
                     {extract the macro parameters}
                     Cmdln:=Copy(MacroText,Posn+3,Length(MacroText)-Posn+2);
                     {send progress information to IDRISI}
                     Idrisi32.PassInProgress(ProcID,Kounter,Lines);
                     {have IDRISI run the macro line}
                     Idrisi32.RunModule(ModName,Cmdln,True,'','','','',True);
                   end;
              until Eof(IML);
              CloseFile(IML);
            end;

       end;

    {indicate to IDRISI that the process has finished its works}
    Idrisi32.ProcessFinished(ProcID);
    {free the IDRISI process ID}
    Idrisi32.FreeProcess(ProcID);

    Close;

    {unregister as a client of IDRISI}
    Idrisi32:=Nil;

End;

Procedure TfrmBatch_Macro.BtnCancelClick(Sender: TObject);

Begin

  Close;

End;

Procedure TfrmBatch_Macro.ComboBox1Change(Sender: TObject);

Begin

  if ComboBox1.ItemIndex=0 then
    Mask.Text:='*.rst'
  else if ComboBox1.ItemIndex=1 then
    Mask.Text:='*.vct'
  else if ComboBox1.ItemIndex=2 then
    Mask.Text := '*.avl'
  else if ComboBox1.ItemIndex=3 then
    Mask.Text := '*.*'
  else if ComboBox1.ItemIndex=4 then
    begin
      Mask.Text:='';
      Mask.SetFocus;
    end;

End;

Procedure TfrmBatch_Macro.FormCreate(Sender: TObject);

Begin

   ComboBox1.ItemIndex:=0;

   if Idrisi32 = Nil then  Idrisi32:=coIdrisiAPIServer.Create;

   DirectoryListBox1.Directory:=Idrisi32.GetWorkingDir;
   MacroName.Text:=Idrisi32.GetWorkingDir+'test.IML';

End;

End.
